
/**
 * Title:        Approximations Simulation<p>
 * Description:  Simulation sur des exemples de divers algorithmes d'approximation pour la compression de chanes de caractres utilisant des grammaires non contextuelles.<p>
 * Copyright:    Copyright (c) Ccile Malinaud/Yann Ponty<p>
 * Company:      <p>
 * @author Ccile Malinaud/Yann Ponty
 * @version 1.0
 */
package approximations;

import java.io.*;
import java.util.*;


public class Shuffle
{

  public Shuffle()
  {
  }

  public static String usage =
    "Usage : java - cp . approximations.Shuffle fichier\n\n"
    +"       fichier : le chemin du fichier a melanger ";


  public static void main(String[] args)
  {
    if(args.length<1)
    {
      System.err.println("Erreur : Nom de fichier requis !");
      System.err.println(usage);
      System.exit(1);
    }
    try
    {
      FileReader fr = new FileReader(args[0]);
      StreamTokenizer parser = new StreamTokenizer(fr);
      parser.resetSyntax();
      parser.slashSlashComments(false);
      parser.slashStarComments(false);
      parser.eolIsSignificant(true);
      parser.wordChars((int)'a',(int)'z');
      parser.wordChars((int)'A',(int)'Z');
      parser.wordChars((int)'0',(int)'1');
      parser.wordChars((int)'',(int)'');
      parser.wordChars((int)'',(int)'');
      parser.wordChars((int)'',(int)'');
      parser.wordChars((int)'',(int)'');
      parser.wordChars((int)'',(int)'');
      parser.wordChars((int)'',(int)'');
      parser.wordChars((int)'',(int)'');
      parser.whitespaceChars((int)' ',(int)' ');
      int ttype = parser.nextToken();
      Vector v = new Vector();
      while(ttype != StreamTokenizer.TT_EOF)
      {
        switch(ttype)
        {
          case(StreamTokenizer.TT_EOL) :
          {
            v.add("\n");
          }
          break;
          case(StreamTokenizer.TT_WORD) :
          {
            v.add(parser.sval);
          }
          break;
          case(StreamTokenizer.TT_NUMBER) :
          {
            v.add(""+parser.nval);
          }
          break;
          default :
          {
            v.add(""+(char) ttype);
          }
          break;
        }

        ttype = parser.nextToken();
      }

      Random gen = new Random(System.currentTimeMillis());

      for(int i=0;i<v.size();i++)
      {
        int index1 = gen.nextInt(v.size());
        int index2 = gen.nextInt(v.size());
        String tmp1 = (String)v.elementAt(index1);
        String tmp2 = (String)v.elementAt(index2);
        v.set(index1,tmp2);
        v.set(index2,tmp1);
      }
      for(int i=0;i<v.size();i++)
      {
        System.out.print((String)v.elementAt(i)+" ");
      }
    }
    catch (FileNotFoundException e1)
    {
      System.err.println("Erreur : Fichier \""+args[0]+"\" introuvable !");
      System.err.println(usage);
      System.exit(1);
    }
    catch (IOException e2)
    {
      System.err.println("Erreur : Problme I/O pendant le traitement de \""+args[0]+"\" !");
      System.err.println(usage);
      System.exit(1);
    }
  }

}